Attribute VB_Name = "EventHandler_WMConstants"
Option Explicit

'==================================================================
'
' Constants for the event handler
'
' 6 October 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
'==================================================================



Public Type POINTAPI
  X As Long
  Y As Long
End Type

' WM_NOTIFY
Public Type NMHDR
  hWndFrom As Long
  IdFrom As Long
  code As Long
End Type

' Identifiers for the WM_SHOWWINDOW message
Public Enum WinMsgShowWindow
  SW_PARENTCLOSING = 1
  SW_OTHERZOOM = 2
  SW_PARENTOPENING = 3
  SW_OTHERUNZOOM = 4
End Enum

' WM_KEYUP/DOWN/CHAR HIWORD(lParam) flags
Public Enum WinMsgKeyFlags
  KF_EXTENDED = &H100
  KF_DLGMODE = &H800
  KF_MENUMODE = &H1000
  KF_ALTDOWN = &H2000
  KF_REPEAT = &H4000
  KF_UP = &H8000
End Enum

' WM_ACTIVATE state values
Public Enum WinMsgActivateStates
  WA_INACTIVE = 0
  WA_ACTIVE = 1
  WA_CLICKACTIVE = 2
End Enum

' notifications passed in low word of lParam on WM_COMMNOTIFY messages
Public Enum WinMsgCommunication
  CN_RECEIVE = &H1
  CN_TRANSMIT = &H2
  CN_EVENT = &H4
End Enum

' wParam for WM_POWER window message and DRV_POWER driver notification
Public Enum WinMsgPower
  PWR_OK = 1
  PWR_FAIL = (-1)
  PWR_SUSPENDREQUEST = 1
  PWR_SUSPENDRESUME = 2
  PWR_CRITICALRESUME = 3
End Enum

' WM_SYNCTASK Commands
Public Enum WinMsgSyncTasks
  ST_BEGINSWP = 0
  ST_ENDSWP = 1
End Enum

' WM_NCHITTEST and MOUSEHOOKSTRUCT Mouse Position Codes
Public Enum WinMsgMHookStruct
  HTERROR = (-2)
  HTTRANSPARENT = (-1)
  HTNOWHERE = 0
  HTCLIENT = 1
  HTCAPTION = 2
  HTSYSMENU = 3
  HTGROWBOX = 4
  HTSIZE = HTGROWBOX
  HTMENU = 5
  HTHSCROLL = 6
  HTVSCROLL = 7
  HTMINBUTTON = 8
  HTMAXBUTTON = 9
  HTLEFT = 10
  HTRIGHT = 11
  HTTOP = 12
  HTTOPLEFT = 13
  HTTOPRIGHT = 14
  HTBOTTOM = 15
  HTBOTTOMLEFT = 16
  HTBOTTOMRIGHT = 17
  HTBORDER = 18
  HTREDUCE = HTMINBUTTON
  HTZOOM = HTMAXBUTTON
  HTSIZEFIRST = HTLEFT
  HTSIZELAST = HTBOTTOMRIGHT
End Enum

' WM_MOUSEACTIVATE Return Codes
Public Enum WinMsgMouseActivateReturns
  MA_ACTIVATE = 1
  MA_ACTIVATEANDEAT = 2
  MA_NOACTIVATE = 3
  MA_NOACTIVATEANDEAT = 4
End Enum

' WM_SIZE message wParam values
Public Enum WinMsgSize
  SIZE_RESTORED = 0
  SIZE_MINIMIZED = 1
  SIZE_MAXIMIZED = 2
  SIZE_MAXSHOW = 3
  SIZE_MAXHIDE = 4
End Enum

' WM_NCCALCSIZE return flags
Public Enum WinMsgSizeReturns
  WVR_ALIGNTOP = &H10
  WVR_ALIGNLEFT = &H20
  WVR_ALIGNBOTTOM = &H40
  WVR_ALIGNRIGHT = &H80
  WVR_HREDRAW = &H100
  WVR_VREDRAW = &H200
  WVR_REDRAW = (WVR_HREDRAW Or WVR_VREDRAW)
  WVR_VALIDRECTS = &H400
End Enum

' Key State Masks for Mouse Messages
Public Enum WinMsgMouseKeyStates
  MK_LBUTTON = &H1
  MK_RBUTTON = &H2
  MK_SHIFT = &H4
  MK_CONTROL = &H8
  MK_MBUTTON = &H10
End Enum

' WM_COPYDATA
Public Type COPYDATASTRUCT
  dwData As Long
  cbData As Long
  lpData As Long
End Type

' WM_GETMINMAXINFO Type
Public Type MINMAXINFO
  ptReserved As POINTAPI
  ptMaxSize As POINTAPI
  ptMaxPosition As POINTAPI
  ptMinTrackSize As POINTAPI
  ptMaxTrackSize As POINTAPI
End Type

' WM_WINDOWPOSCHANGING/CHANGED struct pointed to by lParam
Public Type WINDOWPOS
  hWnd As Long
  hWndInsertAfter As Long
  X As Long
  Y As Long
  cx As Long
  cy As Long
  Flags As Long
End Type


' __________________________________________
' Window Messages

Public Enum WindowMessages
  WM_NULL = &H0
  WM_CREATE = &H1
  WM_DESTROY = &H2
  WM_MOVE = &H3
  WM_SIZE = &H5
  WM_ACTIVATE = &H6
  WM_SETFOCUS = &H7
  WM_KILLFOCUS = &H8
  WM_ENABLE = &HA
  WM_SETREDRAW = &HB
  WM_SETTEXT = &HC
  WM_GETTEXT = &HD
  WM_GETTEXTLENGTH = &HE
  WM_PAINT = &HF
  WM_CLOSE = &H10
  WM_QUERYENDSESSION = &H11
  WM_QUIT = &H12
  WM_QUERYOPEN = &H13
  WM_ERASEBKGND = &H14
  WM_SYSCOLORCHANGE = &H15
  WM_ENDSESSION = &H16
  WM_SHOWWINDOW = &H18
  WM_WININICHANGE = &H1A
  WM_DEVMODECHANGE = &H1B
  WM_ACTIVATEAPP = &H1C
  WM_FONTCHANGE = &H1D
  WM_TIMECHANGE = &H1E
  WM_CANCELMODE = &H1F
  WM_SETCURSOR = &H20
  WM_MOUSEACTIVATE = &H21
  WM_CHILDACTIVATE = &H22
  WM_QUEUESYNC = &H23
  WM_GETMINMAXINFO = &H24
  WM_PAINTICON = &H26
  WM_ICONERASEBKGND = &H27
  WM_NEXTDLGCTL = &H28
  WM_SPOOLERSTATUS = &H2A
  WM_DRAWITEM = &H2B
  WM_MEASUREITEM = &H2C
  WM_DELETEITEM = &H2D
  WM_VKEYTOITEM = &H2E
  WM_CHARTOITEM = &H2F
  WM_SETFONT = &H30
  WM_GETFONT = &H31
  WM_SETHOTKEY = &H32
  WM_GETHOTKEY = &H33
  WM_QUERYDRAGICON = &H37
  WM_COMPAREITEM = &H39
  WM_COMPACTING = &H41
  WM_OTHERWINDOWCREATED = &H42    '  no longer suported
  WM_OTHERWINDOWDESTROYED = &H43  '  no longer suported
  WM_COMMNOTIFY = &H44            '  no longer suported
  WM_WINDOWPOSCHANGING = &H46
  WM_WINDOWPOSCHANGED = &H47
  WM_POWER = &H48
  WM_COPYDATA = &H4A
  WM_CANCELJOURNAL = &H4B
  WM_NCCREATE = &H81
  WM_NCDESTROY = &H82
  WM_NCCALCSIZE = &H83
  WM_NCHITTEST = &H84             ' Every Mouse Action (mX = LoWord(lParam), mY = HiWord(lParam)
  WM_NCPAINT = &H85
  WM_NCACTIVATE = &H86
  WM_GETDLGCODE = &H87
  WM_NCMOUSEMOVE = &HA0
  WM_NCLBUTTONDOWN = &HA1
  WM_NCLBUTTONUP = &HA2
  WM_NCLBUTTONDBLCLK = &HA3
  WM_NCRBUTTONDOWN = &HA4
  WM_NCRBUTTONUP = &HA5
  WM_NCRBUTTONDBLCLK = &HA6
  WM_NCMBUTTONDOWN = &HA7
  WM_NCMBUTTONUP = &HA8
  WM_NCMBUTTONDBLCLK = &HA9
  WM_KEYFIRST = &H100
  WM_KEYDOWN = &H100
  WM_KEYUP = &H101
  WM_CHAR = &H102
  WM_DEADCHAR = &H103
  WM_SYSKEYDOWN = &H104
  WM_SYSKEYUP = &H105
  WM_SYSCHAR = &H106
  WM_SYSDEADCHAR = &H107
  WM_KEYLAST = &H108
  WM_INITDIALOG = &H110
  WM_COMMAND = &H111
  WM_SYSCOMMAND = &H112
  WM_TIMER = &H113
  WM_HSCROLL = &H114
  WM_VSCROLL = &H115
  WM_INITMENU = &H116
  WM_INITMENUPOPUP = &H117
  WM_MENUSELECT = &H11F
  WM_MENUCHAR = &H120
  WM_ENTERIDLE = &H121
  WM_CTLCOLORMSGBOX = &H132
  WM_CTLCOLOREDIT = &H133
  WM_CTLCOLORLISTBOX = &H134
  WM_CTLCOLORBTN = &H135
  WM_CTLCOLORDLG = &H136
  WM_CTLCOLORSCROLLBAR = &H137
  WM_CTLCOLORSTATIC = &H138
  WM_MOUSEFIRST = &H200
  WM_MOUSEMOVE = &H200
  WM_LBUTTONDOWN = &H201
  WM_LBUTTONUP = &H202
  WM_LBUTTONDBLCLK = &H203
  WM_RBUTTONDOWN = &H204
  WM_RBUTTONUP = &H205
  WM_RBUTTONDBLCLK = &H206
  WM_MBUTTONDOWN = &H207
  WM_MBUTTONUP = &H208
  WM_MBUTTONDBLCLK = &H209
  WM_MOUSELAST = &H209
  WM_PARENTNOTIFY = &H210
  WM_ENTERMENULOOP = &H211
  WM_EXITMENULOOP = &H212
  WM_MDICREATE = &H220
  WM_MDIDESTROY = &H221
  WM_MDIACTIVATE = &H222
  WM_MDIRESTORE = &H223
  WM_MDINEXT = &H224
  WM_MDIMAXIMIZE = &H225
  WM_MDITILE = &H226
  WM_MDICASCADE = &H227
  WM_MDIICONARRANGE = &H228
  WM_MDIGETACTIVE = &H229
  WM_MDISETMENU = &H230
  WM_DROPFILES = &H233
  WM_MDIREFRESHMENU = &H234
  WM_CUT = &H300
  WM_COPY = &H301
  WM_PASTE = &H302
  WM_CLEAR = &H303
  WM_UNDO = &H304
  WM_RENDERFORMAT = &H305
  WM_RENDERALLFORMATS = &H306
  WM_DESTROYCLIPBOARD = &H307
  WM_DRAWCLIPBOARD = &H308
  WM_PAINTCLIPBOARD = &H309
  WM_VSCROLLCLIPBOARD = &H30A
  WM_SIZECLIPBOARD = &H30B
  WM_ASKCBFORMATNAME = &H30C
  WM_CHANGECBCHAIN = &H30D
  WM_HSCROLLCLIPBOARD = &H30E
  WM_QUERYNEWPALETTE = &H30F
  WM_PALETTEISCHANGING = &H310
  WM_PALETTECHANGED = &H311
  WM_HOTKEY = &H312
  WM_PENWINFIRST = &H380
  WM_PENWINLAST = &H38F
  
' NOTE: All Message Numbers below WM_USER are RESERVED.
' Private Window Messages Start Here:
  WM_USER = &H400
End Enum

Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (DestPtr As Any, SourcePtr As Any, ByVal NumOfBytes As Long)
